/* Copyright (C) 2006 Imperial College London and others.

 Please see the AUTHORS file in the main source directory for a full list
 of copyright holders.

 Dr Gerard J Gorman
 Applied Modelling and Computation Group
 Department of Earth Science and Engineering
 Imperial College London

 g.gorman@imperial.ac.uk

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA
*/
#ifndef H_COMMUNICATIONTOOLS
#define H_COMMUNICATIONTOOLS

#include <confdefs.h>

#include <mpi.h>
#include <vector>

// The purpose of this routine to is coordinate the sending and
// receiving of a vector of packed buffers. The idea is that no-one
// knows in advance how much information that they have to
// receive. For this reason everyone has to communicate something with
// everyone. For this reason, the size of sendbuffer is assumed to be
// the number of processors. Each pair item in the send/recv Buffer
// represents the size of the buffer in char's, and then a vector
// containing the actual buffer.
void allSendRecv(const std::vector< std::pair<int, std::vector<char> > >& sendBuffer, 
		 std::vector< std::pair<int, std::vector<char> > >& recvBuffer);
void allSendRecv(std::vector< std::vector<char> >& inout);


void allSendRecv(const std::vector< std::vector<unsigned> >& sendBuffer, 
		 std::vector< std::vector<unsigned> >& recvBuffer);
#endif
